#include "stdafx.h"
#include "PaintProcs.h"
#include "Main.h"

#define COUNTOF(array) (sizeof(array)/sizeof(array[0]))

HWND	g_main_window;

HGDIOBJ	g_oroginal_pen=NULL;
HGDIOBJ	g_oroginal_brush=NULL;

HGDIOBJ	g_current_pen=NULL;
HGDIOBJ	g_current_brush=NULL;

HDC		g_current_dc=NULL;

void PaintObjectsPrepare(HDC dc, int width, int hight)
{
	if(g_current_pen!=NULL)
		g_oroginal_pen=SelectObject(dc,g_current_pen);
	if(g_current_brush!=NULL)
		g_oroginal_brush=SelectObject(dc,g_current_brush);

	g_current_dc=dc;
	PaintObjects(dc,width,hight);
	g_current_dc=NULL;

	if(g_oroginal_pen!=NULL)
		SelectObject(dc,g_oroginal_pen);
	if(g_oroginal_brush!=NULL)
		SelectObject(dc,g_oroginal_brush);
	g_oroginal_pen=NULL;
	g_oroginal_brush=NULL;

}


void SetFillColor(int red, int green, int blue)
{
	LOGBRUSH	lb;

	if(g_current_brush!=NULL)
		DeleteObject(g_current_brush);

	lb.lbStyle = BS_SOLID; 
	lb.lbHatch = 0; 
	lb.lbColor = RGB(red,green,blue); 
	g_current_brush=CreateBrushIndirect(&lb);

	if(g_current_dc!=NULL)
	{
		HGDIOBJ	oroginal_brush;
		oroginal_brush=SelectObject(g_current_dc,g_current_brush);
		if(g_oroginal_brush==NULL)
			g_oroginal_brush=oroginal_brush;
	}
}

void SetFillColorEmpty()
{
	LOGBRUSH	lb;

	if(g_current_brush!=NULL)
		DeleteObject(g_current_brush);

	lb.lbStyle = BS_NULL; 
	lb.lbHatch = 0; 
	lb.lbColor = RGB(0,0,0); 
	g_current_brush=CreateBrushIndirect(&lb);

	if(g_current_dc!=NULL)
	{
		HGDIOBJ	oroginal_brush;
		oroginal_brush=SelectObject(g_current_dc,g_current_brush);
		if(g_oroginal_brush==NULL)
			g_oroginal_brush=oroginal_brush;
	}
}

void SetContourLineColor(int red, int green, int blue)
{
	LOGBRUSH		lb;

	if(g_current_pen!=NULL)
		DeleteObject(g_current_pen);

	lb.lbStyle = BS_SOLID; 
	lb.lbHatch = 0; 
	lb.lbColor = RGB(red,green,blue); 
	g_current_pen=ExtCreatePen(PS_GEOMETRIC | PS_SOLID, 1, &lb, 0, NULL); 

	if(g_current_dc!=NULL)
	{
		HGDIOBJ	oroginal_pen;
		oroginal_pen=SelectObject(g_current_dc,g_current_pen);
		if(g_oroginal_pen==NULL)
			g_oroginal_pen=oroginal_pen;
	}

}

void PaintTriangle(HDC dc, int x1, int y1, int x2, int y2, int x3, int y3)
{
	POINT poligon[]={ {x1,y1}, {x2,y2}, {x3,y3}};
	Polygon(dc,poligon,COUNTOF(poligon));
}

void PaintLine(HDC dc, int x1, int y1, int x2, int y2)
{
	POINT line_points[]={ {x1,y1}, {x2,y2} };
	Polyline(dc,line_points,COUNTOF(line_points));
}

void PaintUpdateNow()
{
	RedrawWindow(g_main_window,NULL,NULL,/*RDW_NOERASE|*/RDW_ERASE|RDW_INVALIDATE|RDW_UPDATENOW);
}

void PaintText(HDC dc, int x, int y, char* text)
{
	int text_len=strlen(text);
	TextOut(dc,x,y,text,text_len);
}
